import QtQuick 2.0
import QtQuick.Window 2.2
Window {
	title: "DrawApp"; width: 800; height: 600
	Canvas {
		id: canvas; width: parent.width; height: parent.height
		onPaint: {
			var context = canvas.getContext("2d");

			// Лінія.
			context.beginPath(); // підготувались до малювання фігури
			context.strokeStyle = "blue" // вибрали колір контуру
			context.moveTo(20, 50);
			context.lineTo(400, 20); 
			context.stroke(); // намалювали контур лінії
		
			// Круг.
		    context.beginPath();
   			context.lineWidth = 2; // вибрали товшину контуру
		    context.fillStyle = "green"; // вибрали колір фарбування
		    context.strokeStyle = "red";
		    context.arc(width / 2, height / 2, 60, 0, 2 * Math.PI, true);
		    context.fill(); // зафарбували круг
		    context.stroke(); // намалювали контур кругу
		    
			// Прямокутник.
			context.beginPath();
			context.rect(500, 30, 190, 100);
			context.fill();
			context.stroke();

			context.lineWidth = 1;
			context.strokeStyle = "black";
			context.strokeRect(30, 300, 150, 90); // рамка

		    context.fillStyle = "lightgray";
			context.fillRect(120, 310, 50, 40); // зафарбований прямокутник

		    // Еліпс.
			context.beginPath();
			context.ellipse(20, 100, 290, 100);
		    context.stroke();
		    
		    // Трикутник.
			context.beginPath();
			context.moveTo(460, 250);
			context.lineTo(520, 300);
			context.lineTo(540, 160);
			context.closePath(); // замкнули ламану
			context.fill();
			context.stroke();

			// Графік функції y = cos(x).
			var x, y;
			context.fillStyle = "black";
			for (x = 20; x < (width - 20); x += 0.1) {
				y = Math.cos(x / 40) * 200 + 260;
		        context.fillRect(x, y, 1, 1);
			}
			
		    context.fillStyle = "darkgreen"
		    context.font = "22px sans-serif";
		    context.fillText(
				"На малюнку показано прості фігури та графік функції y = cos(x).",
				20, 530);
			context.fillText("Сергій Вовк. 2016.", 500, 570);
		}
	}
}

