#ifndef FLYELECTRONS_H
#define FLYELECTRONS_H
#include <GL/glu.h>
#include <QGLWidget>
#include <QTimer>
class FlyElectrons : public QGLWidget {
    Q_OBJECT
public:
	class Electron {
	public:
		float orbitRadius, x, y, p, rotationX, rotationY, rotationZ;
		int orbitType, speed;
		Electron(int moveSpeed, float electronOrbitRadius, int electronOrbitType = 1) {
			orbitRadius = electronOrbitRadius;
			orbitType = electronOrbitType;
			x = 0.0;
			y = 0.0;
			p = 0.0;
			speed = moveSpeed;
			if (orbitType == 1) {
				rotationX = rand() % 360;
				rotationY = rand() % 360;
				rotationZ = rand() % 360;
			} else {
				rotationX = 0;
				rotationY = 0;
				rotationZ = 0;
			}
		}
	};
	FlyElectrons(QWidget *parent = 0);
	~FlyElectrons();
protected:
    void initializeGL();
    void resizeGL(int width, int height);
    void paintGL();
	void keyPressEvent(QKeyEvent *event);
	void mouseDoubleClickEvent(QMouseEvent *event);
private slots:
	void onTimeout();
private:
	QList<Electron*> electrons;
	GLUquadric *quad;
	QTimer timer;
	float moveSpeed;
};
#endif
