import QtQuick 2.0
import QtQuick.Controls 1.3
// Хрестики нулики версія 3.
// Сергій Вовк. 2016.

ApplicationWindow {
    title: "Хрестики нулики"; color: "lightgrey"; width: 300; height: 340
    property bool isGameEnded: false
    Text {id: status; x: 15; y: 20; font.pointSize: 17; text: "Ваш хід."}

    Button {
        id: newGameButton; x: 195; y: 20; text: "Нова гра"; visible: false
        onClicked: { // обробка натиснення кнопки "нова гра"
            var a = [b1, b2, b3, b4, b5, b6, b7, b8, b9];
			for (var i in a) a[i].text = "";
            status.text = "Ваш хід.";
            newGameButton.visible = false;
            isGameEnded = false;
        }
    }

    Grid {
        anchors.centerIn: parent; rows: 3; columns: 3; spacing: 3
        Button {id: b1; width: 60; height: 60; onClicked: buttonClick()}
        Button {id: b2; width: 60; height: 60; onClicked: buttonClick()}
        Button {id: b3; width: 60; height: 60; onClicked: buttonClick()}
        Button {id: b4; width: 60; height: 60; onClicked: buttonClick()}
        Button {id: b5; width: 60; height: 60; onClicked: buttonClick()}
        Button {id: b6; width: 60; height: 60; onClicked: buttonClick()}
        Button {id: b7; width: 60; height: 60; onClicked: buttonClick()}
        Button {id: b8; width: 60; height: 60; onClicked: buttonClick()}
        Button {id: b9; width: 60; height: 60; onClicked: buttonClick()}
    }

    // Функція setStatus визначає стан гри по стану кнопок.
    function setStatus(buttonsArray) {
        var x, y, r;
        // Перевірка чи користувач або компьютер виграв.
        for (x = 0; x < 8; x++) {
            r = buttonsArray[x];
			if ((r[0].text != "") && (r[1].text == r[0].text) &&
				(r[2].text == r[0].text)) {
				status.text = ((r[0].text == "x") ? "Ви виграли!" : "Ви програли.");
                newGameButton.visible = true;
                isGameEnded = true;
                return;
            }
        }

        // Перевірка на нічийну.
        for (y = 0; y < 3; y++) for (x = 0; x < 3; x++)
            if (buttonsArray[y][x].text == "") return;
        status.text = "Нічийна.";
        newGameButton.visible = true;
        isGameEnded = true;
    }

    function buttonClick() { // обробка натиснення кнопки.
        if (isGameEnded || (this.text != "")) return;
        // У масиві a визначено рядки кнопок для перевірки.
        var a = [[b1, b2, b3], [b4, b5, b6], [b7, b8, b9], // по горизонталі
                 [b1, b4, b7], [b2, b5, b8], [b3, b6, b9], // по вертикалі
                 [b1, b5, b9], [b3, b5, b7]]; // по диагоналі
        var x, y, r;
        this.text = "x";
        setStatus(a);
        if (isGameEnded) return;

        // Перевірка щоб виграти.
        for (x = 0; x < 8; x++) {
            r = a[x];
            if ((r[0].text == "") && (r[1].text == "0") && (r[2].text == "0"))
                { r[0].text = "0"; setStatus(a); return; }
            if ((r[0].text == "0") && (r[1].text == "") && (r[2].text == "0"))
                { r[1].text = "0"; setStatus(a); return; }
            if ((r[0].text == "0") && (r[1].text == "0") && (r[2].text == ""))
                { r[2].text = "0"; setStatus(a); return; }
        }

        // Перевірка щоб не дати виграти.
        for (x = 0; x < 8; x++) {
            r = a[x];
            if ((r[0].text == "") && (r[1].text == "x") && (r[2].text == "x"))
                { r[0].text = "0"; setStatus(a); return; }
            if ((r[0].text == "x") && (r[1].text == "") && (r[2].text == "x"))
                { r[1].text = "0"; setStatus(a); return; }
            if ((r[0].text == "x") && (r[1].text == "x") && (r[2].text == ""))
                { r[2].text = "0"; setStatus(a); return; }
        }

		//------------------------------------------------------------------
        // Простий хід.

		if ((b5.text == "") && Math.round(Math.random())) {
			b5.text = "0";
			setStatus(a);
			return;
		}

		var emptyButtons = [], cornerButtons = [b1, b3, b7, b9];
		for (x in cornerButtons)
			if (cornerButtons[x].text == "") emptyButtons.push(cornerButtons[x]);
		if (!emptyButtons.length) {
			for (y = 0; y < 3; y++) for (x = 0; x < 3; x++)
				if (a[y][x].text == "") emptyButtons.push(a[y][x]);
		}
		if (!emptyButtons.length) return;
		if (emptyButtons.length == 1) emptyButtons[0].text = "0";
		else emptyButtons[Math.round(Math.random() * (emptyButtons.length - 1))].text = "0";
		setStatus(a);
	}
}
