#include "mainwindow.h"
#include <QApplication>
#include <QMessageBox>
#include <QAction>

MainWindow::MainWindow(QWidget *parent) : QMainWindow(parent) {
	QAction *aboutProgramAction = new QAction("About WebNotifer", this);
	QAction *quitAction = new QAction("Quit", this);
	connect(quitAction, SIGNAL(triggered()), qApp, SLOT(quit()));
	connect(aboutProgramAction, SIGNAL(triggered()), this, SLOT(aboutProgram()));

	trayIconMenu = new QMenu(this);
	trayIconMenu->addAction(aboutProgramAction);
	trayIconMenu->addAction(quitAction);

	trayIcon = new QSystemTrayIcon(this);
	trayIcon->setContextMenu(trayIconMenu);
	QIcon icon(":/icon.png");
	setWindowIcon(icon);
	trayIcon->setIcon(icon);
	trayIcon->setToolTip("WebNotifier");
	trayIcon->show();
}

MainWindow::~MainWindow() {}

void MainWindow::aboutProgram() {
	QMessageBox::information(0, "WebNotifier",
		"WebNotifier version 1.0.\n"
		"Sergiy Vovk. 2015.");
}
