#include <iostream>

// Клас, якій визначає або успадковує
// хоча б одну чисту віртуальну функцію, є абстрактним.
// Не можна створити екземпляр абстрактного класу.
class Alpha { // Абстрактний клас
	virtual void f1() = 0; // Чиста віртуальна функція.
	public: void f2() { f1(); }
};

class Beta : public Alpha { // Клас Beta не абстрактний
	// Якщо клас реалізує чисту віртуальну функцію з базового класу,
	// він перестає бути абстрактним.
	void f1() { std::cout << "Beta::f1() викликана." << std::endl; }
};

int main() {
	Beta b;
	b.f2();
	return 0;
}

