#include <iostream>
#include <any>

void showAny(const std::any& a) {
	if (a.type() == typeid(bool)) std::cout << std::any_cast<bool>(a) << std::endl;
	else if (a.type() == typeid(int)) std::cout << std::any_cast<int>(a) << std::endl;
	else if (a.type() == typeid(double)) std::cout << std::any_cast<double>(a) << std::endl;
	else if (a.type() == typeid(char)) std::cout << std::any_cast<char>(a) << std::endl;
	else if (a.type() == typeid(const char*)) std::cout << std::any_cast<const char*>(a) << std::endl;
	else std::cout << "unknown\n";
}

int main() {
	std::any a[6];
	a[1] = true;
	a[2] = 9;
	a[3] = 5.6;
	a[4] = 'a';
	a[5] = "Check.";
	for (const std::any& e : a) {
		std::cout << "--------------\n";
		std::cout << "Has value: " << std::boolalpha << e.has_value() << std::endl;
		std::cout << "Type: " << e.type().name() << std::endl;
		std::cout << "Value: ";
		showAny(e);
	}
	std::cout << std::endl;

	showAny(6);
	showAny(5.9);
	showAny("Check.");
	std::cout << std::endl;

	try {
		std::cout << std::any_cast<int>(a[1]) << std::endl;
	} catch (const std::bad_any_cast&) {
		std::cout << "bad_any_cast exception.\n";
	}

	return 0;
}
