#include <iostream>
#include <boost/any.hpp>

void showAny(const boost::any& a) {
	if (a.type() == typeid(bool))
		std::cout << boost::any_cast<bool>(a) << std::endl;
	else if (a.type() == typeid(int))
		std::cout << boost::any_cast<int>(a) << std::endl;
	else if (a.type() == typeid(double))
		std::cout << boost::any_cast<double>(a) << std::endl;
	else if (a.type() == typeid(char))
		std::cout << boost::any_cast<char>(a) << std::endl;
	else if (a.type() == typeid(const char*))
		std::cout << boost::any_cast<const char*>(a) << std::endl;
	else cout << "unknown\n";
}

int main() {
	boost::any a[6];
	a[1] = true;
	a[2] = 9;
	a[3] = 5.6;
	a[4] = 'a';
	a[5] = "Check.";
	for (const boost::any& e : a) {
		std::cout << "--------------\n";
		std::cout << "Is empty: " << std::boolalpha << e.empty() << std::endl;
		std::cout << "Type: " << e.type().name() << std::endl;
		std::cout << "Value: ";
		showAny(e);
	}

	std::cout << std::endl;
	showAny(6);
	showAny(5.9);
	showAny("Check.");

	std::cout << std::endl;
	try {
		std::cout << boost::any_cast<int>(a[1]) << std::endl;
	} catch (const boost::bad_any_cast&) {
		std::cout << "bad_any_cast exception.\n";
	}

	return 0;
}
