// Meeds LIBS += -lboost_system -lboost_filesystem
#include <iostream>
#include <boost/filesystem.hpp>
using std::cout;
using namespace boost::filesystem;

int main() {
	cout << std::boolalpha << "/tmp exists: " << exists("/tmp") << "\n";

	cout << "\n/tmp content:\n";
	for (directory_entry& e : directory_iterator("/tmp")) {
		cout << e.path().filename().string();
		if (is_regular_file(e)) cout << " : " << file_size(e) << " bytes";
		cout << '\n';
	}

	cout << "\nCurrent path: " << current_path().string() << "\n";

	cout << "\nCurrent cpp file: " << __FILE__ << "\n";
	path p(__FILE__);
	cout << "File name: " << p.filename().string() << "\n";
	cout << "Extension: " << p.extension().string() << "\n";
	cout << "Parent path: " << p.parent_path().string() << "\n\n";

	cout << "Temp directory path: " << temp_directory_path().string() << "\n";
	path p2(temp_directory_path());
	p2 /= "tmpfile.txt";
	cout << "p2: " << p2.string() << "\n\n";

	save_string_file(p2, "String 1\nString 2\nString 3\nString 4\nString 5\n");
	std::string s;

	try {
		load_string_file(p2, s);
	// В функції load_string_file глюк.
	// При помилці виняток std::ios_base::failure неможливо перехопити.
	// Але його можна перехопити з catch (...).
	} catch (...) {
		cout << "Трапилась помилка завантаження файлу " + p2.string() + ".\n";
		return 1;
	}
	cout << s;

	space_info si = space("/"); // Get file system information.
	cout << "\n\n/ file system space:\n"
		 << "Capacity: "<< si.capacity / 1024 / 1014 / 1024 << " gb.\n"
		 << "Available: "<< si.available / 1024 / 1014 / 1024 << " gb.\n";
	return 0;
}
