﻿#include <iostream>
#include <boost/asio.hpp>
#include <boost/bind.hpp>
#include <boost/thread.hpp>
typedef boost::shared_ptr<boost::asio::ip::tcp::socket> socket_ptr;

void client_session(socket_ptr socket) {
	char data[1024];
	boost::system::error_code err;

	std::cout << "Incoming connection from " <<
		socket->remote_endpoint().address().to_string() << std::endl;

	boost::asio::write(*socket, boost::asio::buffer("Hello.\n", 7));
	for (;;) {
		size_t length = socket->read_some(
				boost::asio::buffer(data, sizeof(data)), err);

		if (err) {
			std::cerr << "Error: " << err.message() << std::endl;
			return;
		}

		std::cout << "Received " << length << " bytes.\n";
		if (length) std::cout << std::string(data, length);
	}
}

int main() {
	const short port = 8080; // listen port

	boost::asio::io_service service;
	boost::asio::ip::tcp::endpoint ep(boost::asio::ip::tcp::v4(), port);
	boost::asio::ip::tcp::acceptor acceptor(service, ep);
	boost::system::error_code err;
	for (;;) {

		// Prepare a socket for future incoming connection.
		socket_ptr socket(new boost::asio::ip::tcp::socket(service));

		acceptor.accept(*socket, err);

		if (err) {
			std::cerr << "Error: " << err.message() << std::endl;
			return 0;
		}

		boost::thread(boost::bind(client_session, socket));
	}
	return 0;
}
