#include <iostream>
#include <typeinfo>

struct A { virtual void f() {} };
struct B : A{};
struct C : A{};

// Якщо клас A неполіморфний то завжди typeid(a) == typeid(A).
// Якщо клас A поліморфний то typeid(a) == typeid(реальний екземпляр).
void f(const A& a) {
	std::cout << typeid(a).name() << std::endl;
	if (typeid(a) == typeid(C)) std::cout << "В функцію f було передано екземпляр класу C.\n";

	// Перевірити клас можна також оператором dynamic_cast.
	try {
		dynamic_cast<const B&>(a);
		std::cout << "В функцію f було передано екземпляр класу B.\n";
	} catch (const bad_cast&) { /* В функцію f було передано екземпляр класу не B. */ }
}

int main() {
	// Мінімальний розмір неполіморфного класу 1 байт.
	// Мінімальний розмір поліморфного класу 8 байт.
	f(A());
	f(B());
	f(C());
	return 0;
}
