#include <iostream>
#include <cstdlib>
#include <cstring>
#include <unistd.h>
#include <sys/socket.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <netdb.h>

const char serverAddress[] = "google.com";
const int port = 80;

void error(const char *msg) {
    perror(msg);
    exit(1);
}

int main() {
	hostent* server = gethostbyname(serverAddress);
	if (server == nullptr) {
		std::cerr << "Error, no such host.\n";
		exit(1);
	}

	int sockfd = socket(AF_INET, SOCK_STREAM, 0);
	if (sockfd < 0) error("Error opening socket");

	sockaddr_in addr = {};
	bcopy((char *)server->h_addr, (char *)&addr.sin_addr.s_addr, server->h_length);
	addr.sin_port = htons(port);
	addr.sin_family = AF_INET;

	// connect блокує програму до тих пір поки не створиться підключення
	// або трапиться помилка.
	if (connect(sockfd, (sockaddr *)&addr, sizeof(addr)) < 0) error("Error connecting");

	const char request[] = "GET / HTTP/1.1\r\n"
	                       "Host: google.com\r\n\r\n";
	int n = write(sockfd, request, strlen(request));
	if (n < 0) error("Error writing to socket");

	char buffer[1024] = {};
	n = read(sockfd, buffer, sizeof(buffer) - 1);
	if (n < 0) error("Error reading from socket");
	std::cout << buffer << std::endl;

	close(sockfd);
	return 0;
}
