#include <iostream>
#include <bitset>

int main() {
	// Клас bitset призначений для компактного зберігання набору бітів.
	std::bitset<32> bs; // Набір 32 бітів.
	std::cout << "Початкове значення bs: " << bs << std::endl;
	std::cout << "Значення першого біту: " << bs[0] << std::endl;
	std::cout << "Чи увімкнуті всі біти: " << std::boolalpha << bs.all() << std::endl;
	std::cout << "Чи вимкнуті всі біти: " << bs.none() << std::endl;
	std::cout << "Чи увімкнутий якийсь біт: " << bs.any() << std::endl;
	bs[0] = bs[1] = 1;
	std::cout << "В bs було увімкнуто 2 перших біти справа.\n";
	std::cout << "Значення bs: " << bs << std::endl;
	std::cout << "Значення першого біту: " << bs[0] << std::endl;
	std::cout << "Чи увімкнутий якийсь біт: " << bs.any() << std::endl;
	std::cout << "Кількість увімкнутих бітів: " << bs.count() << std::endl;
	std::cout << "Десяткове значення bs: " << bs.to_ulong() << std::endl;
	bs.reset();
	std::cout << "Значення bs після скидання: " << bs << std::endl;
	bs.set();
	std::cout << "Значення bs після увімкнення всіх бітів: " << bs << std::endl;
	std::cout << "5 в двійковій системі " << std::bitset<32>(5) << std::endl;
	return 0;
}
