#include <valarray>
#include <iostream>

void show(const std::valarray<int>& a) {
	for (auto it = begin(a); it != end(a); it++) std::cout << *it << ' ';
	std::cout << std::endl;
}

int main() {
	// A valarray object is designed to hold an array of values,
	// and easily perform mathematical operations on them.
	std::valarray<int> a({1, 2, 3, 4, 5, 6, 7, 8, 9});
	std::cout << "Зміст масиву a: ";
	show(a);

	std::cout << "Кількість елементів в масиві a: " << a.size() <<std:: endl
	          << "Сума чисел в масиві a: " << a.sum() << std::endl
	          << "Мінімальне число в масиві a: " << a.min() << std::endl
	          << "Максимальне число в масиві a: " << a.max() << std::endl;

	a += 1;
	std::cout << "Зміст масиву a після добавки до кожного числа 1: ";
	show(a);

	a *= 10;
	std::cout << "Зміст масиву a після множення кожного числа на 10: ";
	show(a);

	a /= 5;
	std::cout << "Зміст масиву a після ділення кожного числа на 5: ";
	show(a);

	// Піднесемо числа в масиві a в степінь 3 і результат збережемо в масив b.
	std::valarray<int> b(pow(a, 3));
	std::cout << "Зміст масиву b: ";
	show(b);
	return 0;
}
