#include <iostream>
#include <vector>

// vector це динамічний масив.

void show(std::vector<int>& v) {
	for (std::vector<int>::iterator it = v.begin(); it != v.end(); it++)
		std::cout << *it << ' ';
	std::cout << std::endl;
}

int main() {
	std::vector<int> v1 = {5, 9, 8, 4, 2, 3, 6, 7, 1};
	std::cout << "v1 size: " << v1.size() << std::endl;
	std::cout << "Is v1 empty: " << v1.empty() << std::endl;

	for (int i : v1) std::cout << i << ' ';
	std::cout << std::endl;

	// Доступ до елементу по індексу. Функція at працює так само як оператор [].
	// Функція at повертає посилання на елемент вказаного індексу.
	std::cout << v1.at(1) << std::endl;

	// Функція front повертає посилання на перший елемент.
	// Функція back повертає посилання на останій елемент.
	std::cout << "First element of v1: " << v1.front() << std::endl;
	std::cout << "Last element of v1: " << v1.back() << std::endl;

	v1.pop_back(); // Видалили останій елемент.

	for (int i = 0; i < v1.size(); i++) std::cout << v1[i] << ' ';
	std::cout << std::endl;

	v1.push_back(6); // Добавили елемент в кінець.
	show(v1);

	v1.insert(v1.begin() + 3, 9); // Вставили елемиент.
	show(v1);

	v1.erase(v1.begin() + 1); // Видалили другий элемент.
	show(v1);

	v1.clear(); // Очистили вектор.
	std::cout << "v1 size: " << v1.size() << std::endl;

	v1.resize(30); // Змінили розмір вектору.
	std::cout << "v1 size: " << v1.size() << std::endl;

	int n = 1;
	for (std::vector<int>::iterator it = v1.begin(); it != v1.end(); it++) *it = n++;
	show(v1);

	v1.assign(3, 10); // Наповнили вектор. Передали кількість та значення.
	show(v1);

	v1.assign({5, 6, 7, 8, 9}); // Наповнили вектор.
	show(v1);

	int a[] = {1, 2, 3, 4, 5, 6};
	v1.assign(a, a + 6); // Наповнили вектор по масиву.
	show(v1);

	std::vector<int> v2(a,  a + 6); // Ініціалізация вектора по масиву.
	show(v2);

	std::vector v3{5, 6, 7, 8, 9}; // Дедукція C++17.
	show(v3);

	std::vector<int> v4(v1); // Ініціалізация вектора по іншому вектору.
	std::cout << "v4 size: " << v4.size() << std::endl;
	show(v4);

	std::vector<int> v5(v1.begin(), v1.end()); // Ініціалізация вектора по іншому вектору.
	show(v5);

	std::vector<int> v6(10); // Створили вектор з 10 елементами.
	std::cout << "v6 size: " << v6.size() << std::endl;
	n = 1;
	for (std::vector<int>::iterator it = v6.begin(); it != v6.end(); it++) *it = n++;
	show(v6);

	std::vector<int> v7(5, 10); // Створили вектор з 5 елементами які ініційовані значенням 10.
	std::cout << "v7 size: " << v7.size() << std::endl;
	show(v7);

	std::vector<int> v8({5, 6, 7, 8, 9}); // Ініціалізация вектору по списку.
	show(v8);

	return 0;
}
