#include <iostream>
#include <filesystem>

int main() {
	std::cout << std::boolalpha << "/tmp exists: " << std::filesystem::exists("/tmp") << "\n";

	std::cout << "\n/tmp content:\n";
	for (const std::filesystem::directory_entry& e : std::filesystem::directory_iterator("/tmp")) {
		std::cout << e.path().filename().string();
		if (std::filesystem::is_regular_file(e))
			std::cout << " : " << std::filesystem::file_size(e) << " bytes";
		std::cout << '\n';
	}

	std::cout << "\nCurrent path: " << std::filesystem::current_path().string() << "\n";

	std::cout << "\nCurrent cpp file: " << __FILE__ << "\n";
	std::filesystem::path p(__FILE__);
	std::cout << "File name: " << p.filename().string() << "\n";
	std::cout << "Extension: " << p.extension().string() << "\n";
	std::cout << "Parent path: " << p.parent_path().string() << "\n\n";

	std::cout << "Temp directory path: " << std::filesystem::temp_directory_path().string()
	          << std::endl;
	std::filesystem::path p2(std::filesystem::temp_directory_path());
	p2 /= "tmpfile.txt";
	std::cout << "p2: " << p2.string() << std::endl << std::endl;

	std::filesystem::space_info si = std::filesystem::space("/"); // Get file system information.
	std::cout << "/ file system space:\n"
	          << "Capacity: "<< si.capacity / 1024 / 1014 / 1024 << " gb.\n"
	          << "Available: "<< si.available / 1024 / 1014 / 1024 << " gb.\n";
	return 0;
}
