#include <iostream>
class B;

class A {
	friend B;
	friend void friendFunction();
	private: void f() { std::cout << "A::f була викликана.\n"; }
};

class B {
	public: void f() {
		std::cout << "B::f була викликана.\n";
		// Клас B має доступ до приватних елементів класу A
		// тому що клас A обявив клас B своїм другом.
		A a;
		a.f();
		// Якби клас A не обявив клас B своїм другом, була б помилка компіляції
		// ‘void A::f()’ is private within this context.
	 };
};

void friendFunction() {
	std::cout << "friendFunction була викликана.\n";
	// Функція friendFunction має доступ до приватних елементів класу A
	// тому що клас A обявив функцію friendFunction своїм другом.
	A a;
	a.f();
	// Якби клас A не обявив функцію friendFunction своїм другом,
	// була б помилка компіляції ‘void A::f()’ is private within this context.
}

int main() {
	B b;
	b.f();
	friendFunction();
	return 0;
}
