#include <iostream>
#include <vector>
#include <algorithm>
#include <functional> // В бібліотеці functional є готові функтори.
#include <iterator>

// Функціональний об'єкт (функтор).
struct sum { int operator() (int a, int b) { return a + b; } };

// Елементи struct за замовчанням public. Елементи class за замовчанням private.

// Unary функтор має 1 аргумент. Binary функтор має 2 аргументи.

int main() {
	sum f;
	std::cout << "5 + 4 = " << f(5, 4) << std::endl;

	std::vector<int> v1({10, 20, 30, 40, 50, 60}), v2({1,  2,  3,  4,  5,  6}), v3;
	std::transform( v1.begin(), v1.end(), v2.begin(), std::back_inserter(v3), std::plus<int>() );
	// plus це стандартний binary функтор з бібліотеки functional.

	std::cout << "Елементи v3: ";
	std::copy( v3.begin(), v3.end(), std::ostream_iterator<int>(std::cout, " ") );
	std::cout << std::endl;
	return 0;
}
