// Спеціалізація функції дозволяє виначити окрему шаблонну функцію для певного типу.
#include <iostream>
#include <typeinfo>

void showTypeInfo(const std::type_info& t) {
	std::cout << "Type hash code: " << t.hash_code() << std::endl;
	std::cout << "Type name: " << t.name() << std::endl;
	std::cout << "Real type name: ";
	std::cout.flush();
	system(("echo " + std::string(t.name()) + " | c++filt -t").c_str());
	std::cout << std::boolalpha << "Is type int: " << ( t == typeid(int) ) << std::endl;
}

template<class T> void f(T /* a */ ) {
	std::cout << "Була викликана не спеціалізована функція f.\n";
	showTypeInfo(typeid(T));
}

template<> void f<double> (double a) {
	std::cout << "Була викликана функція f для double.\n";
	showTypeInfo(typeid(a));
}

template<> void f<int> (int a) {
	std::cout << "Була викликана функція f для int.\n";
	showTypeInfo(typeid(a));
}

int main() {
	f(true);
	std::cout << std::endl;
	f('a');
	std::cout << std::endl;
	f('b');
	std::cout << std::endl;
	f("a");
	std::cout << std::endl;
	f(9.5); // double
	std::cout << std::endl;
	f(5.6f); // float
	std::cout << std::endl;
	f(9l); // long
	std::cout << std::endl;
	f(9);
	return 0;
}
