#include <iostream>
#include <cmath>

class Line {
public:
	class Point {
	public:
		Point() {
			x = y = 0;
		}
		Point(int x, int y) {
			this->x = x;
			this->y = y;
		}
		void showInfo() {
			std::cout << "x: " << x << ", y: " << y << std::endl;
		}
		int x, y;
	};

	Line() {
		point1 = Point();
		point2 = Point();
	}

	Line(int x1, int y1, int x2, int y2) {
		point1 = Point(x1, y1);
		point2 = Point(x2, y2);
	}

	int getLength() {
		return sqrt(
				pow(point1.x - point2.x, 2) +
				pow(point1.y - point2.y, 2));
	}

	void showInfo() {
		std::cout << "Point 1:\n";
		point1.showInfo();
		std::cout << "Point 2:\n";
		point2.showInfo();
		std::cout << "Line length: " << getLength() << std::endl;
	}

	Point point1, point2;
};

int main() {
	Line line(5, 9, 40, 96);
	line.showInfo();

	// Якби клас Point був у секції private, його не можна було б використати поза класу Line.
	Line::Point point(4, 6);
	point.showInfo();

	return 0;
}
