#include <iostream>

// lvalue це об'єкт який має адресу в оперативній памяті і цьому об'єкті можна присвоїти значення.
// rvalue це протилежне від lvalue. Об'єкту rvalue не можна присвоїти значення.

// Звичайне посилання може вказувати тільки на об'єкт lvalue.
// Константне посилання може вказувати на об'єкт lvalue або rvalue.
void f(int& i) {
	std::cout << "void f(int& i) was invoked.\n";
	std::cout << i << std::endl;
}

// Іноді потрібно створити окрему функцію яка б приймала об'єкт rvalue.
// Посилання && може вказувати тільки на об'єкт rvalue.
void f(int&& i) {
	std::cout << "void f(int&& i) was invoked.\n";
	std::cout << i << std::endl;
}

int main() {
	int i = 5;
	f(i); // Буде викликана функція void f(int& i) тому що i це об'єкт lvalue.
	f(9); // Буде викликана функція void f(int&& i) тому що i це об'єкт rvalue.
	return 0;
}
