#include <vector>
#include <ctime>
#include <regex>
#include <iostream>

int main() {
	std::vector<std::string> v;
	for (int i = 1; i < 1000000; i++) v.push_back("Number " + std::to_string(i));

	clock_t begin = clock();

	unsigned sum = 0;
	std::smatch sm;
	std::regex r("Number (\\d+)");
	for (const std::string& s : v) {
		if (std::regex_match(s, sm, r)) sum += std::stoi(sm[1]);
	}

	clock_t end = clock();
	double elapsedSeconds = double(end - begin) / CLOCKS_PER_SEC;
	std::cout << "Sum: " << sum << std::endl
	          << "Elapsed seconds: " << elapsedSeconds << std::endl;
	return 0;
}
