/*
Таблиця приоритетів.

Приоритет  Оператор
1          ::
2          ++ Інкремент у вигляді суфікса
           -- Декремент у вигляді суфікса
           () Виклик функції
           [] Індексація масиву
           .
           ->
           typeid()
           const_cast Перетворення типів
           dynamic_cast Перетворення типів
           reinterpret_cast Перетворення типів
           static_cast Перетворення типів
3          ++ Інкремент у вигляді префіксу
           -- Декремент у вигляді префіксу
           + Унарний плюс
           - Унарний мінус
           ! Логічне НЕ
           ~ Побітове НЕ
           (type) Перетворення типів
           * Розіменування
           & Отримання адреси
           sizeof
           new, new[]
           delete, delete[]
4          .* Вказівник на член
           ->* Вказівник на член
5          * Множення
           / Ділення
           % Отримання залишку ділення
6          + Додавання
           - Віднімання
7          << Побітовий зсув вліво
           >> Побітовий зсув вправо
8          <
           <=
           >
           >=
9          ==
           !=
10         &
11         ^ Побітове виключне АБО
12         |
13         &&
14         ||
15         ?: Тернарний умовний оператор
16         = Пряме присвоєння
           += Присвоєння суми
           -= Присвоєння різниці
           *= Присвоєння добутку
           /= Присвоєння частки
           %= Присвоєння залишку
           <<= Присвоєння побітового зсуву вліво
           >>= Присвоєння побітового зсуву вправо
           &= Присвоєння побітового І
           ^= Присвоєння побітового виключного АБО
           |= Присвоєння побітового АБО
17         throw
18         ,

Таблиця пріоритету визначає порядок застосування операторів у складних виразах,
коли цей порядок не заданий явно за допомогою круглих дужок.
*/

#include <iostream>

int sum(int a, int b) {
	std::cout << "Була викликана функція sum.\n";
	return a + b;
}

int main() {
	int i = 9;
	if ( (i == 5) || (i == 9) ) std::cout << "Check 1.\n";
	// Дужки необовязкові тому що оператори порівняння мають більший приориет ніж
	// логічні оператори.
	if (i == 5 || i == 9) std::cout << "Check 2.\n";

// Однак операція справа логічного оператора не буде виконана при певній умові зліва.
// Тут функція sum не виконається тому що результат справа логічного оператора не важливий.
	if (i == 5 && sum(i, 6) == 15) std::cout << "Check 3.\n";
	if (i == 9 || sum(i, 10) == 19) std::cout << "Check 4.\n";

	int a = 4;
	// В арифметичних операторах більший приоритет ніж в операторах порівняння.
	if (i == a + 5) std::cout << "Check 5.\n";

	std::cout << 2 + 3 * 4 << std::endl; // Результат 14. В * / % більший приоритет ніж в + -.
	return 0;
}
