#include <iostream>

int& f(int& a) {
//	int i = 5;
//	cout << "Адреса f::i: " << &i << endl;
//	return i; // Не можна повертати посилання на локальну змінну.
//	return a + 4; // Не можна повертати посилання на тимчасове значення.
	return a;
}

int& f2() {
	static int i = 5;
	std::cout << "Адреса f2::i: " << &i << std::endl;
	return i; // Можна повертати посилання на статичну локальну змінну.
}

class A {
	int i = 5;
public:
	A() { std::cout << "Викликано конструктор A.\nАдреса A::i: " << &i << std::endl; }
	~A() { std::cout << "Викликано деструктор A.\n"; }
	int& f() {
		return i; // Можна повертати посилання на член класу.
		// Повернуте посилання дійсне поки екземпляр класу існує.

		// Якщо повернуте посилання використати після знищення екземпляру класу,
		// програма буде працювати не правильно.
	}
};

int main() {
	int i = 5;
	int& n1 = f(i);
	int n2 = f(i);
	std::cout << "Адреса i:  " << &i << std::endl;
	std::cout << "Адреса n1: " << &n1 << std::endl;
	std::cout << "Адреса n2: " << &n2 << std::endl << std::endl;

	int& n3 = f2();
	std::cout << "Адреса n3: " << &n3 << std::endl << std::endl;

//	int& n4 = A().f(); // Анонімний екземпляр класу знищується після ;.
	A a;
	int& n4 = a.f();
	std::cout << "Адреса n4: " << &n4 << std::endl;
	return 0;
}
