#include <regex>
#include <iostream>

int main() {
	// regex_match перевіряє чи регулярний вираз цілком відповідає стрічці.
	std::cout << std::regex_match("subject", std::regex("(sub)(.*)")) << std::endl; // 1
	std::cout << std::regex_match("a", std::regex("(a|b|c)")) << std::endl; // 1
	std::cout << std::regex_match("ab", std::regex("(a|b|c)")) << std::endl; // 0
	std::cout << std::regex_match("z", std::regex("(a|b|c)")) << std::endl; // 0

	std::cmatch cm; // Для string є smatch.
	if (regex_match("numbers 956 369 935", cm,
					std::regex("numbers (\\d+) (\\d+) (\\d+)"))) {
		std::cout << "Кількість знайдених результатів: " << cm.size() << std::endl;
		for (unsigned i = 0; i < cm.size(); i++)
			std::cout << "cm[" << i << "] = " << cm[i] << std::endl;
	}

	// regex_search шукає регулярний вираз в середині стрічки.
	std::cout << std::regex_search("a xyz", std::regex("(a|b|c)")) << std::endl; // 1
	std::cout << std::regex_search("123456789xyz", std::regex("(a|b|c)")) << std::endl; // 0

	std::cout << std::regex_replace("abc 95 46 945", std::regex("\\d+"), "number") << std::endl;
	// Результат: abc number number number
/*
В стрічці заміни можут бути коди:

$n
n-th backreference (i.e., a copy of the n-th matched group specified with
 arentheses in the regex pattern).
n must be an integer value designating a valid backreference,
greater than 0, and of two digits at most.

$&	A copy of the entire match.
$$	A single $ character.
*/
	std::cout << std::regex_replace("abc 95", std::regex("(\\d+)"), "number $1") << std::endl;
	// Результат: abc number 95

	std::cout << std::regex_replace("abc 95, 46, 945", std::regex("\\d+"), "\"$&\"")
	          << std::endl;
	// Результат: abc "95", "46", "945"
	return 0;
}
