// Коротка довідка про стандартні функції C.

// assert.h
assert //  Evaluate assertion

//--------------------------------------------------------------------------------------------

// ctype.h

int isalnum(int c);
// Check if character is alphanumeric
// Checks whether c is either a decimal digit or an uppercase or lowercase letter.
// Return Value: A value different from zero (i.e., true)
// if indeed c is either a digit or a letter. Zero (i.e., false) otherwise.

isalpha // Check if character is alphabetic
isblank // Check if character is blank
iscntrl // Check if character is a control character
isdigit // Check if character is decimal digit
isgraph // Check if character has graphical representation
islower // Check if character is lowercase letter
isprint // Check if character is printable
ispunct // Check if character is a punctuation character
isspace // Check if character is a white-space
isupper // Check if character is uppercase letter
isxdigit // Check if character is hexadecimal digit

int tolower(int c); // Convert uppercase letter to lowercase
int toupper(int c); // Convert lowercase letter to uppercase

//--------------------------------------------------------------------------------------------

// errno.h
errno // Last error number

//--------------------------------------------------------------------------------------------

// locale.h
char* setlocale(int category, const char* locale); // Set or retrieve locale

//--------------------------------------------------------------------------------------------

// math.h
ceil  // Round up value
floor // Round down value
trunc // Truncate value
round //  Round to nearest

//--------------------------------------------------------------------------------------------

// signal.h
signal // Set function to handle signal
raise // Generates a signal

//--------------------------------------------------------------------------------------------

// stdarg.h
va_start // Initialize a variable argument list
va_arg // Retrieve next argument
va_end // End using variable argument list

//--------------------------------------------------------------------------------------------

// stdio.h

remove // Remove file
rename // Rename file
tmpfile // Open a temporary file
tmpnam  // Generate temporary filename

fclose // Close file
fflush // Flush stream
fopen // Open file
freopen // Reopen stream with different file or mode

fprintf // Write formatted data to stream
fscanf // Read formatted data from stream

printf // Print formatted data to stdout
// On success, the total number of characters written is returned.
// If a writing error occurs, the error indicator (ferror) is set
// and a negative number is returned.

scanf // Read formatted data from stdin
/*
On success, the function returns the number of items of the argument list successfully filled.
This count can match the expected number of items
or be less (even zero) due to a matching failure, a reading error,
or the reach of the end-of-file.
If a reading error happens or the end-of-file is reached while reading,
the proper indicator is set (feof or ferror).
And, if either happens before any data could be successfully read, EOF is returned.
*/

fgetc, getc // Get character from stream
fgets // Get string from stream
fputc, putc // Write character to stream
fputs // Write string to stream

getchar // Get character from stdin
gets // Get string from stdin
putchar // Write character to stdout
puts // Write string to stdout

fread // Read block of data from stream
fwrite // Write block of data to stream

fgetpos, ftell // Get current position in stream
fseek // Reposition stream position indicator
fsetpos // Set position indicator of stream
rewind // Set position of stream to the beginning

clearerr // Clear error indicators
feof // Check end-of-file indicator
ferror // Check error indicator
perror // Print error message

//--------------------------------------------------------------------------------------------

// stdlib.h

atof // Convert string to double
atoi /// Convert string to integer
atol // Convert string to long integer

strtod // Convert string to double
strtof // Convert string to float
strtol // Convert string to long integer
strtoul // Convert string to unsigned long integer

rand // Generate random number
srand // Initialize random number generator

calloc // Allocate and zero-initialize array
free // Deallocate memory block
malloc // Allocate memory block
realloc // Reallocate memory block

abort // Abort current process
atexit // Set function to be executed on exit
at_quick_exit // Set function to be executed on quick exit
exit // Terminate calling process
quick_exit // Terminate calling process quick

getenv // Get environment string
system // Execute system command

bsearch // Binary search in array
qsort // Sort elements of array
mblen // Get length of multibyte character

//--------------------------------------------------------------------------------------------

// string.h

memcpy // Copy block of memory
memmove // Move block of memory
strcpy // Copy string
strncpy // Copy characters from string
strcat // Concatenate strings
strncat // Append characters from string

memcmp // Compare two blocks of memory
strcmp // Compare two strings
strcoll // Compare two strings using locale
strncmp  // Compare characters of two strings

strxfrm // Transform string using locale

memchr // Locate character in block of memory
strchr // Locate first occurrence of character in string
strcspn // Get span until character in string
strpbrk // Locate characters in string
strrchr // Locate last occurrence of character in string
strspn // Get span of character set in string
strstr // Locate substring
strtok // Split string into tokens

memset // Fill block of memory
strerror // Get pointer to error message string
strlen // Get string length

//--------------------------------------------------------------------------------------------

// time.h

clock // Clock program
time // Get current time
difftime // Return difference between two times

mktime // Convert tm structure to time_t
asctime // Convert tm structure to string

ctime // Convert time_t value to string

gmtime // Convert time_t to tm as UTC time
localtime // Convert time_t to tm as local time

// Format time as string.
size_t strftime(char* ptr, size_t maxsize, const char* format, const struct tm* timeptr);
