#include <iostream>
#include <string>
#include <cstring>

void show(const std::string& s) {
	std::cout << s << std::endl;
}

int main() {
	std::string s;

	s = "string";
	show(s);
	std::cout << "Size: " << s.size() << std::endl; // Розмір стрічки.

	s += " another string"; // Добавляємо стрічку.
	show(s);
	std::cout << "Size: " << s.size() << std::endl;

	s += " 3th"; // Дрбавляємо ще одну стрічку.
	show(s);

 	s[1] = 'b'; // Замінюємо 2-й символ.
	show(s);
 	s[0] = 'a';
 	s[2] = 'c';
 	s[3] = 'd';
	show(s);

	// Шукаєио стрічку "another" в s:
	// i буде позиція першого символу знайденої стрічки.
	int i = s.find("another");
	if (i != std::string::npos) { // Якщо знайдено.
		std::cout << "i  = " << i  << std::endl;
		s.replace(i, strlen("another"), "wonderful"); // Замінюємо "another" на "wonderful".
		show(s);
	}

	s.erase(0, 5); // Видаляємо шматок стрічки.
	show(s);

	// Вставляємо стрічку "second " на 10-ту позицію:
	s.insert(10, "second ");
	show(s);

	// Витягуємо підстрічку (вказуємо позицію та довжину).
	show(s.substr(17, 6));

	// Порівняння.
	s = "abc";
	show(s);
	std::cout <<  "s == \"abc9\" : " << (s == "abc9")  << std::endl;
	std::cout <<  "s == \"abc\" : " << (s == "abc")  << std::endl;

	return 0;
}
