#include <iostream>
#include <sstream>
#include <algorithm>
#include <iterator>
#include <vector>

// Перевантажуємо оператор << для виводу значень vector в ostream.
template <typename T>
std::ostream& operator<< (std::ostream& out, const std::vector<T>& v) {
	if (v.empty()) return out;
	out << '[';
	std::copy (v.begin(), v.end(), std::ostream_iterator<T>(out, ", "));
	out << "\b\b]";
	return out;
}

int main() {
	// stringstream дозволяє створити в оперативній памяті стрічку,
	// з якою можна працювати як з потоком.
	std::stringstream ss;

	// Добавляємо дані в ss.
	int i;
	for (i = 1; i < 10; i++) {
		if (i > 1) ss << ' ';
		ss << i;
	}
	std::cout << "Зміст ss: " << ss.str() << std::endl;

	// Читаємо числа з ss і добавляємо в масив v.
	std::vector<int> v;
	while (ss >> i) v.push_back(i);

	ss.clear(); // Set goodbit error flag.
	ss.seekg(0); // Set position.
	std::cout << "Повторне читання чисел з ss: ";
	while (ss >> i) std::cout << i << ' ';
	std::cout << std::endl;

	std::cout << "Зміст масиву v: [";
	std::copy(v.begin(), v.end(), std::ostream_iterator<int>(std::cout, ", "));
	// \b - backspace.
	std::cout << "\b\b]\n";

	std::transform(v.begin(), v.end(), v.begin(), [](int i){ return i * 10; });
	std::cout << "Зміст ss після множення елементів на 10: " << v << std::endl;
	return 0;
}
