#include <iostream>
#include <boost/type_index.hpp>

template<class T, bool debug = true> class NumberPair {
public:
	T n1, n2;

	NumberPair(T _n1, T _n2) {
		n1 = _n1;
		n2 = _n2;
	}

	void show() {
		if (debug)
			std::cout << "T class: " << boost::typeindex::type_id<T>().pretty_name() << std::endl;
		std::cout << n1 << " " << n2 << std::endl;
	}

	void swap() {
		T t = n1;
		n1 = n2;
		n2 = t;
	}

	T sum() {
		return n1 + n2;
	}
};

int main() {
	NumberPair p1(4, 5);
	p1.show();

	std::cout << "--------------------\n";
	NumberPair p2(1.4, 1.5);
	p2.show();

	std::cout << "--------------------\n";
	NumberPair<int, false> p3(5, 9);
	p3.show();
	p3.swap();
	p3.show();
	std::cout << "Sum: " << p3.sum() << std::endl;

	return 0;
}
