#include <iostream>
#include <variant>

int main() {
	std::variant<int, double, std::string> v;

	v = 39;
	if (std::holds_alternative<int>(v)) { // Перевірка чи значення v типу int.
		std::cout << "v: " << std::get<int>(v) << std::endl;
		// В std::get також можна вказати індекс типу.
		std::cout << "v: " << std::get<0>(v) << std::endl;
		std::cout << "v.index(): " << v.index() << std::endl;
	}

	v = 5.6;
	std::cout << "v: " << std::get<double>(v) << std::endl;
	std::cout << "v.index(): " << v.index() << std::endl;

	v = "abc";
	std::cout << "v: " << std::get<std::string>(v) << std::endl;
	std::cout << "v.index(): " << v.index() << std::endl;

	try {
		std::cout << std::get<int>(v) << std::endl;
	} catch (std::bad_variant_access&) {
		std::cout << "Трапився виняток bad_variant_access.\n";
	}

	return 0;
}
