//   / .
// Sergiy Vovk, 2008.

#include <stdio.h> 
#include <string.h> //  strcmpi,strcpy,strcat,strlen,strrchr
#include <time.h> //  clock, gmtime 
//   stdio.h   printf,getchar,
// fopen,fclose,fseek,ftell,fgets,fgetc,fputc,fread,fwrite.

//    ˳     strcmpi.
// ,  strcmpi  ,    strcmp:
#ifndef strcmpi
#define strcmpi strcmp
#endif
// г strcmpi  strcmp   ,  strcmpi 
//        .

//         ,
// ,     .
#define BUFER_SIZE 32768 // 32 

//   / (  ):
char password[128] = "qxefkjr34p[56-ft6t52!fr5tej%^fz";

int main(int argc, char* argv[]) {
	//  :
	unsigned char bufer[BUFER_SIZE], b[1024];
	FILE *f_in, *f_out;
	unsigned int i; int pc, last_pc = -1, is_encoding;
	unsigned long processed_bytes = 0, file_size,
	              check_sum = 0, real_check_sum = 0;
	char szOutFileName[512], szOriginalExt[256];
	char *p = &password[0], *pDot;
	clock_t start_time, end_time;
	time_t t; struct tm* ptm; size_t n;
	unsigned char orig_ext_len;
// p -      ( 1-  ).

	printf("\t\t\txor_encoding v1.2\n");
	printf("\t\t\tProgram for encoding/decoding files\n");
	printf("\t\t\t(c) Sergey Vovk, 2008\n\n");

	if (argc < 2) { //    
		printf("Input file was not specified.\n");
		return 1; //   
	}

// r - for reading; w - for writing; b - binary mode.
	// argv[1] -   ,   .
	// ³    :
	f_in = fopen(argv[1], "rb");
	if (f_in == NULL) { //  
		printf("Cannot open input file \"%s\".\n",
		       argv[1]);
		return 2; //   
	}

	//  file_size   :
	fseek(f_in, 0, SEEK_END); //    
	file_size = ftell(f_in); // ftel  
	fseek(f_in, 0, SEEK_SET); //  

	//    :
	printf("Input file size: %lu bytes.\n", file_size);
	//    :
	printf("Input file: \"%s\".\n", argv[1]);

	//  szOutFileName    :
	strcpy(szOutFileName, argv[1]);

	
	// -    szOutFileName:
	pDot = strrchr(szOutFileName, '.');
	//   ,      xef:
	// (,      .xef)
	if ( pDot && (strcmpi(pDot, ".xef") == 0) ) {
		is_encoding = 0; // ,   
		*pDot = '\0'; //  xef     

		//   4-     :
		n = fread(&real_check_sum, sizeof(real_check_sum), 1, f_in);
		//  if (n != 1) ... // ...

		//  5-     :
		orig_ext_len = fgetc(f_in);
		if (orig_ext_len)	{ //    
			// C   szOriginalExt:
			fgets(szOriginalExt, orig_ext_len + 1, f_in);
			//      :
			strcat(szOutFileName, ".");
			strcat(szOutFileName, szOriginalExt);
		}
		processed_bytes = sizeof(real_check_sum) + 1 + orig_ext_len;

	} else { //  -,  
		is_encoding = 1;
		if (pDot) { //   
			//   :
			strcpy(szOriginalExt, pDot + 1);
			//     :
			*pDot = '\0';
		} else //   
			szOriginalExt[0] = '\0'; // 

		//       .xef -
		//      .
		strcat(szOutFileName, ".xef");
	}

	//    :
	printf("Output file: \"%s\".\n", szOutFileName);
	//   ,   :
	printf("\t%s...\n", is_encoding ? "Encoding" : "Decoding");

	

	// ,      ?
	// (     )
	// ³    :
	f_out = fopen(szOutFileName, "rb");
	if (f_out) { //  szOutFileName  
		fclose(f_in); //   
		fclose(f_out); //   
		//  :
		printf("ATTENTION! Output file \"%s\" already exists.\n",
		       szOutFileName);
		printf("Press enter to exit.\n");
		i = getchar(); //      
		return 3; //   
	}


	//    -i :
	if ( (argc == 3) && (strcmpi(argv[2], "-i") == 0) ) {
		//    : 
		printf("Input password: ");
		fgets(password, sizeof(password), stdin);
		if (password[0] == '\0') { //   
			fclose(f_in); //   
			printf("Operation is canceled.\n");
			return 10; //   
		}
		printf("\n");
	}


			//    :
	if (is_encoding == 0) { //   
		printf("real_check_sum = %lu\n", real_check_sum);

//        :
		//   1024    :
		n = fread(b, sizeof(char), 1024, f_in);
		// if (n == 0) ... // 

		// ³ ,    fread:
		fseek(f_in, sizeof(real_check_sum) + 1 + orig_ext_len,
		      SEEK_SET);

//        :
		for (i = 0; i < n; i++) {
			check_sum += ( b[i] ^ (unsigned char)*p );
			p++; 
			if ( (*p) == '\0' ) p = &password[0];
		}
		
		printf("check_sum = %lu\n", check_sum);
		//        ,
		//     :
		if (check_sum != real_check_sum) {
			fclose(f_in); //   
			// " ²!"
			printf("\t\t\tPASSWORD IS WRONG!\n");
			printf("Press enter to exit.\n");
			i = getchar();
			return 15; //   
		}

		p = &password[0];
	} // if (is_encoding == 0)


	// ³    :
	f_out = fopen(szOutFileName, "wb");
	if (f_out == NULL) { //  
		fclose(f_in); //   
		printf("Cannot open output file \"%s\" for writing.\n",
		       szOutFileName);
		return 4; //   
	}


			//      :
	if (is_encoding) { //   
//     1024   :
// (  ,    < 1024 ):
		//	   1024 :
		n = fread(b, sizeof(char), 1024, f_in);
		// if (n == 0) ... //   
		fseek(f_in, 0, SEEK_SET); //  
		for (i = 0; i < n; i++) check_sum += b[i]; //  

//  1-, 2-, 3-, 4-  f_out   :
		fwrite(&check_sum, sizeof(check_sum), 1, f_out);

		printf("check_sum = %lu\n", check_sum);
		printf("sizeof(check_sum) = %d bytes\n", sizeof(check_sum) );
		
//  5-   f_out     :
		fputc( (unsigned char)strlen(szOriginalExt), f_out );
		fputs(szOriginalExt, f_out); //   
	} // if (is_encoding)

	
	start_time = clock(); //   
	for (;;) {
		// n -       .
		//      f_in 
		//  BUFER_SIZE-   bufer:
		n = fread(bufer, sizeof(char), BUFER_SIZE, f_in);
		//     ,  for (;;):
		if (n == 0) break;

		//	     bufer  :
		for (i = 0; i < n; i++) {
			//   bufer[i]    :
			bufer[i] = (bufer[i] ^ (unsigned char)*p);
//   .    .:
			p++; 
//      ,   :
			if ( (*p) == '\0' ) p = &password[0];
		} //    for (i = 0; i < n; i++)

		//    (n-)   f_out:
		fwrite(bufer, sizeof(char), n, f_out);

		processed_bytes += n;
		//  pc    :
		pc = (int)
			( ((double)processed_bytes) / ((double)file_size) * 100.0 );
		if (pc != last_pc) { //   
			//      :
			printf("Processed bytes: %lu ( %d %% )\r",
			       processed_bytes, pc);
			last_pc = pc; //  
		} //   if
	} //    for (;;)


	end_time = clock(); //   
	// ³     :
	printf("\nDone. Elapsed time: %f second ",
	  ( (float)(end_time - start_time) ) / (float)CLOCKS_PER_SEC);

	//  :     ::
	t = (end_time - start_time) / CLOCKS_PER_SEC;
	ptm = gmtime(&t);
	printf("( %u:%02u:%02u )\n",
	       ptm->tm_hour, ptm->tm_min, ptm->tm_sec);

	fclose(f_in); //   
	fclose(f_out); //   
	printf("Press enter to exit.\n");
	i = getchar(); //      
	return 0; // 0 -   
} //    main

/*
   clock   
( )    .
    ,   
    CLOCKS_PER_SEC.
clock      
 .

   gmtime    
( 0:00:00 1-01-1980  )   tm.
  gtime    
//.

		// ^ -   XOR:
			// 0 ^ 0 = 0
			// 0 ^ 1 = 1
			// 1 ^ 0 = 1
			// 1 ^ 1 = 0
*/
