#include <graphics.h>
#include <conio.h>
#include <dos.h>
#include <stdio.h>
#include <math.h>

//  :
const R_X = 250, R_Y = 230, R_WIDTH = 150, R_HEIGHT = 100;
const P_Z = 30; //  
double dCurAngle = 0.0; //  

void tetragon(pointtype* pts) { //  
	int cds[10];
	for (int i = 0; i < 4; i++) {
		cds[i * 2] = pts[i].x;     // cds: 0, 2, 4, 6
		cds[i * 2 + 1] = pts[i].y; // cds: 1, 3, 5, 7
	}
	cds[8] = cds[0]; cds[9] = cds[1]; // :
	drawpoly(5, cds); //  
}

void parallelepiped() { //  
	//   2- :
	pointtype R1[4], R2[4];

	 //    :
	R1[0].x = R_X; R1[0].y = R_Y;

	R1[1].x = (int) ( cos(dCurAngle) * ((double)R_WIDTH) + (double)R_X );
	R1[1].y = (int) ( sin(dCurAngle) * ((double)R_WIDTH) + (double)R_Y );

	double dDiagonal = sqrt( pow(R_WIDTH, 2) + pow(R_HEIGHT, 2) ),
	       dAngleBetween_W_D;
	dAngleBetween_W_D = acos(R_WIDTH / dDiagonal);
	R1[2].x = (int) ( cos(dCurAngle + dAngleBetween_W_D) * dDiagonal + (double)R_X );
	R1[2].y = (int) ( sin(dCurAngle + dAngleBetween_W_D) * dDiagonal + (double)R_Y );

	R1[3].x = (int) ( cos(dCurAngle + (M_PI / 2)) * ((double)R_HEIGHT) + (double)R_X );
	R1[3].y = (int) ( sin(dCurAngle + (M_PI / 2)) * ((double)R_HEIGHT) + (double)R_Y );

	tetragon(R1); //   

	//       P_Z:
	for (int i = 0; i < 4; i++) {
		R2[i].x = R1[i].x + P_Z;
		R2[i].y = R1[i].y + P_Z;
	}
	tetragon(R2);

	// '   :
	for (i = 0; i < 4; i++)
		line(R1[i].x, R1[i].y, R2[i].x, R2[i].y);
}

int main() {
	int gdriver = DETECT, gmode, errorcode; char s[32];
	initgraph(&gdriver, &gmode, "");

	errorcode = graphresult(); //   
	if (errorcode != grOk) { //   
		printf("Error: %s\nPress any key.\n", 
		       grapherrormsg(errorcode));
		getch();
		return;
	}

	outtextxy(20, 20, "Programed by Sergey Vovk at 15-02-2008.");
	setfillstyle(SOLID_FILL, BLACK);
	while (kbhit() == 0) { //     ...
		setcolor(BLACK);
		parallelepiped(); //  

		dCurAngle += 0.05; //   
		if (dCurAngle > (M_PI * 2 )) dCurAngle = 0.0;
		setcolor(WHITE);
		parallelepiped(); //  
 
		sprintf(s, "Angle: %d",
		        (int) ( 180.0 * dCurAngle / M_PI ) );
		bar(100,40,190,60);
		outtextxy(100, 40, s);

		delay(400); //  400
	}
	closegraph();
	return 0;
}
