#include <windows.h> 
#include <math.h>
void Line(HDC hDcDst, int x1, int y1, int x2, int y2);
void SetPaintColor(HDC hDcDst, COLORREF color);
void SetOutlineColor(HDC hDcDst, COLORREF color);

//    :
#define W_WIDTH 640
#define W_HEIGHT 480

//  :
#define BLACK   RGB(0x00,0x00,0x00)
#define WHITE   RGB(0xFF,0xFF,0xFF)
#define RED     RGB(0xFF,0x00,0x00)
#define GREEN   RGB(0x00,0xFF,0x00)
#define BLUE    RGB(0x00,0x00,0xFF)

void PaintFn(HDC hDC) {
	Ellipse(hDC, 10, 10, 90, 40); // 
	Ellipse(hDC, 100, 10, 140, 50); // 
	SetPixel(hDC, 30, 25, BLACK); // 
	Line(hDC, 10, 50, 90, 50); // 
	Rectangle(hDC, 10, 60, 140, 80); // 
	Rectangle(hDC, 150, 10, 220, 80); // 

	// :
	POINT mpt1[5];
	mpt1[0].x = 10;	 mpt1[0].y = 130;
	mpt1[1].x = 120; mpt1[1].y = 180;
	mpt1[2].x = 220; mpt1[2].y = 130;
	mpt1[3].x = 340; mpt1[3].y = 180;
	mpt1[4].x = 460; mpt1[4].y = 130;
	Polyline(hDC, mpt1, sizeof(mpt1) / sizeof(POINT));  

	// :
	POINT mpt2[7];
	mpt2[0].x = 10;	 mpt2[0].y = 190;
	mpt2[1].x = 200; mpt2[1].y = 220;
	mpt2[2].x = 300; mpt2[2].y = 200;
	mpt2[3].x = 460; mpt2[3].y = 230;
	mpt2[4].x = 400; mpt2[4].y = 330;
	mpt2[5].x = 200; mpt2[5].y = 310;
	mpt2[6].x = 175; mpt2[6].y = 240;
	Polygon(hDC, mpt2, sizeof(mpt2) / sizeof(POINT));  

	//    :
	SetOutlineColor(hDC, RED);
	Rectangle(hDC, 10, 90, 220, 120);

	SetOutlineColor(hDC, BLACK); //  
	SetPaintColor(hDC, GREEN);
	Ellipse(hDC, 250, 30, 320, 100); //  

	//  y = cos(x):
	double x, y;
	for (x = 0.0; x < 640.0; x+=0.1) {
		y = cos(x / 40) * 180 + 200;
		SetPixel(hDC, (int)x, (int)y, BLACK);
	}

	//  y = k / x:
	for (x = 0.0; x < 640.0; x+=0.01) {
		y = 5000.0 / x;
		SetPixel(hDC, (int)x, (int)y, BLUE);
	}

} //   PaintFn

HBRUSH hLastUsedBrush = 0; HPEN hLastUsedPen = 0;

LRESULT CALLBACK MainWindowProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	switch (uMsg) {
	case WM_PAINT:
		{
			PAINTSTRUCT ps;
			BeginPaint(hWnd, &ps);
			PaintFn(ps.hdc);
			EndPaint(hWnd, &ps);
		}
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam); 
	} 
	return 0; 
} 

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) {
	WNDCLASS wc = {0}; MSG msg;
	wc.lpfnWndProc   = MainWindowProc;
	wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wc.hInstance     = hInstance;
	wc.lpszClassName = "TestWinClass";
	wc.hbrBackground = (HBRUSH)COLOR_WINDOWFRAME;
	RegisterClass(&wc);

	HWND hW = CreateWindow(
		"TestWinClass", " ",
		WS_CAPTION | WS_MINIMIZEBOX | WS_SYSMENU, 
		CW_USEDEFAULT, 0, // x  y 
		W_WIDTH + (GetSystemMetrics(SM_CYFIXEDFRAME) * 2),
		W_HEIGHT + (GetSystemMetrics(SM_CXFIXEDFRAME) * 2) + GetSystemMetrics(SM_CYCAPTION),
		0, 0, hInstance, 0);
	ShowWindow(hW, nCmdShow);

	while (GetMessage(&msg, 0, 0, 0)) DispatchMessage(&msg); 
	// if (hLastUsedBrush) DeleteObject(hLastUsedBrush); 
	// if (hLastUsedPen) DeleteObject(hLastUsedPen); 
	return msg.wParam;
}

void Line(HDC hDcDst, int x1, int y1, int x2, int y2) {
	MoveToEx(hDcDst, x1, y1, 0);
	LineTo(hDcDst, x2, y2);
}

void SetPaintColor(HDC hDcDst, COLORREF color) {
	HBRUSH hNewBrush = CreateSolidBrush(color);
	SelectObject(hDcDst, hNewBrush);
	if (hLastUsedBrush) DeleteObject(hLastUsedBrush); 
	hLastUsedBrush = hNewBrush;
}

void SetOutlineColor(HDC hDcDst, COLORREF color) {
	HPEN hNewPen = CreatePen(PS_SOLID, 0, color);
	SelectObject(hDcDst, hNewPen);
	if (hLastUsedPen) DeleteObject(hLastUsedPen); 
	hLastUsedPen = hNewPen;
}

//      v3.
//  , 2005 - 2009.
