#include <windows.h>
// #include <commdlg.h>
#include <commctrl.h>
#include <windowsx.h> 
// #include <stdlib.h>


HWND hTab, hStc;
// hStc - handle to static control in
// tab control's display area.

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) { 
	switch (uMsg) { 
	case WM_SIZE: 
		{ 
			HDWP hdwp; RECT rc;

// Calculate the display rectangle, assuming the 
// tab control is the size of the client area. 
			SetRect(&rc, 0, 0,
			        GET_X_LPARAM(lParam),
			        GET_Y_LPARAM(lParam));
			TabCtrl_AdjustRect(hTab, FALSE, &rc);

			hdwp = BeginDeferWindowPos(2);
			
// Size the tab control to fit the client area.
			DeferWindowPos(
					hdwp, hTab, NULL, 0, 0,
					GET_X_LPARAM(lParam),
					GET_Y_LPARAM(lParam),
					SWP_NOMOVE | SWP_NOZORDER);

// Position and size the static control to fit the 
// tab control's display area, and make sure the 
// static control is in front of the tab control. 
			DeferWindowPos(
					hdwp, hStc, HWND_TOP,
					rc.left, rc.top,
					rc.right - rc.left,
					rc.bottom - rc.top, 0); 

			EndDeferWindowPos(hdwp);
		}
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default: 
		return DefWindowProc(hWnd, uMsg, wParam, lParam); 
	} 
	return 0; 
} 

int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) {
	WNDCLASS wc = {0}; TCITEM tie = {0}; MSG msg;
	HWND hMainWin;

	InitCommonControls();

	wc.lpfnWndProc   = MainWndProc;
	wc.hCursor       = LoadCursor(NULL, IDC_ARROW);
	wc.hInstance     = hInstance;
	wc.lpszClassName = "TestWinClass";
	wc.hbrBackground = (HBRUSH)COLOR_WINDOWFRAME;
	RegisterClass(&wc);
	hMainWin = CreateWindow(
					"TestWinClass", "This is test",
					WS_OVERLAPPEDWINDOW,
					CW_USEDEFAULT, 0,
					CW_USEDEFAULT, 0,
					0, 0, hInstance, 0);

	hTab = CreateWindow(
					WC_TABCONTROL, "",
					WS_CHILD | WS_CLIPSIBLINGS | WS_VISIBLE,
					0, 0, 0, 0, hMainWin, 0,
					hInstance, 0);

	tie.mask = TCIF_TEXT;
	tie.pszText = "";
	TabCtrl_InsertItem(hTab, 0, &tie);
	tie.pszText = "";
	TabCtrl_InsertItem(hTab, 1, &tie);

	hStc = CreateWindow(
					"STATIC", "Label",
					WS_CHILD | WS_VISIBLE | WS_BORDER | SS_CENTER,
					0, 0, 0, 0, hMainWin, 0,
					hInstance, 0);

	ShowWindow(hMainWin, nCmdShow);

	while (GetMessage(&msg, 0, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg);
	}
	return msg.wParam;
}
