#include <windows.h>
#include <commctrl.h>
#define ID_TOOLBAR 4203
HINSTANCE hInst;

LRESULT CALLBACK MainWndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	switch (uMsg) {
	case WM_SIZE:
		SendMessage(GetDlgItem(hWnd, ID_TOOLBAR),
		            TB_AUTOSIZE, 0, 0);
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, uMsg, wParam, lParam);
	}
	return 0;
}

void InitApp(int iMainWinCmdShow) {
	WNDCLASS wc = {0}; HWND hMainWin, hBar;
	TBBUTTON tb[7]; int iNumberOfButtons, i;

	InitCommonControls(); 
	
	wc.lpfnWndProc   = MainWndProc;
	wc.hInstance     = hInst;
	wc.lpszClassName = "TestWinClass";
	wc.hbrBackground = (HBRUSH)COLOR_WINDOWFRAME;
	RegisterClass(&wc);

	hMainWin = CreateWindow(
					"TestWinClass", "This is test",
					WS_OVERLAPPEDWINDOW,
					CW_USEDEFAULT, 0,
					CW_USEDEFAULT, 0,
					0, 0, hInst, 0);
	
	ZeroMemory(tb, sizeof(tb));
	iNumberOfButtons = sizeof(tb) / sizeof(TBBUTTON);
	for (i = 0; i < iNumberOfButtons; i++) {
		tb[i].fsState = TBSTATE_ENABLED;
		tb[i].fsStyle = TBSTYLE_BUTTON;
	}

	tb[0].iBitmap = STD_FILENEW;
	tb[0].iString = 0;
	tb[1].iBitmap = STD_FILEOPEN;
	tb[1].iString = 1;
	tb[2].iBitmap = STD_FILESAVE;
	tb[2].iString = 2;
	tb[3].fsStyle = TBSTYLE_SEP;
	tb[4].iBitmap = STD_CUT;
	tb[4].iString = 3;
	tb[5].iBitmap = STD_COPY;
	tb[5].iString = 4;
	tb[6].iBitmap = STD_PASTE;
	tb[6].iString = 5;

	hBar = CreateToolbarEx(
				hMainWin, WS_CHILD | WS_VISIBLE,
				ID_TOOLBAR, 0, HINST_COMMCTRL,
				IDB_STD_LARGE_COLOR, tb,
				iNumberOfButtons, 0, 0, 0, 0,
				sizeof(TBBUTTON));
	SendMessage(hBar, TB_ADDSTRING, 0,
	            (LPARAM)"New\0Open\0Save\0Cut\0Copy\0Paste\0");

	ShowWindow(hMainWin, iMainWinCmdShow);
}


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow) {
	MSG msg;
	hInst = hInstance;
	InitApp(nCmdShow);
	while (GetMessage(&msg, 0, 0, 0)) {
		TranslateMessage(&msg);
		DispatchMessage(&msg); 
	}
	return msg.wParam;
}
