#include <atlbase.h>
#include <atlapp.h>
extern CAppModule _Module;
#include <atlwin.h>
#include <atlframe.h>
#include <atlgdi.h>
#include <atlmisc.h>
#include <math.h>
#define BLACK RGB(0x00,0x00,0x00)

class CMainWindow : public CFrameWindowImpl<CMainWindow> {
public:
	BEGIN_MSG_MAP(CMainWindow)
		MESSAGE_HANDLER(WM_PAINT, OnPaint)
		CHAIN_MSG_MAP(CFrameWindowImpl<CMainWindow>)
	END_MSG_MAP()

	LRESULT OnPaint(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled) {
		CPaintDC dc(m_hWnd);

		dc.SetPixel(140, 30, BLACK); // point
		dc.MoveTo(10, 50); dc.LineTo(90, 50); // line
		dc.Rectangle(10, 60, 140, 80);
		dc.Ellipse(10, 10, 90, 40);

		POINT v1[4];
		v1[0].x = 10;  v1[0].y = 130;
		v1[1].x = 120; v1[1].y = 170;
		v1[2].x = 70;  v1[2].y = 110;
		v1[3].x = 160; v1[3].y = 150;
		dc.Polyline(v1, sizeof(v1) / sizeof(POINT));

		POINT v2[5];
		v2[0].x = 210; v2[0].y = 90;
		v2[1].x = 200; v2[1].y = 120;
		v2[2].x = 410; v2[2].y = 150;
		v2[3].x = 430; v2[3].y = 100;
		v2[4].x = 250; v2[4].y = 70;
		dc.Polygon(v2, sizeof(v2) / sizeof(POINT));

		//    :
		dc.RoundRect(470, 50, 590, 120, //  
		             40, 40); // ,    

		double x, y;
		for (x = 20.0; x < 600.0; x+=0.1) {
			y = cos(x / 40) * 70 + 280;
			dc.SetPixel((int)x, (int)y, BLACK);
		}

		dc.DrawText("Sergiy Vovk, 2012.", -1,
		            CRect(10, 410, 300, 450), DT_CENTER);
		return 0;
	}
};

CAppModule _Module;

int WINAPI
WinMain(HINSTANCE hInstance, HINSTANCE, LPSTR, int nCmdShow) {
	_Module.Init(0, hInstance);

	CMainWindow wnd;
	wnd.Create(
		0, CRect(0,0,640,480), "WTLGraphicApp",
		WS_CAPTION | WS_MINIMIZEBOX | WS_SYSMENU);
	wnd.CenterWindow();
	wnd.ShowWindow(nCmdShow);

	CMessageLoop loop;
	int r = loop.Run();

	_Module.Term();
	return r;
}
