#include <cmath>
#include <GL/glut.h> // Пакунок freeglut-devel.

void renderScene() {
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glColor3d(1.0, 1.0, 1.0);

	glBegin(GL_TRIANGLES);

		// Трикутник 1.
		glVertex2d(-0.8, 0.5 );
		glVertex2d(-0.6, 0.8);
		glVertex2d(-0.5, 0.5);

		// Трикутник 2.
		glVertex2d(-0.8, -0.5);
		glVertex2d(-0.6, -0.2);
		glVertex2d(-0.5, -0.5);

	glEnd();

	glBegin(GL_QUADS);

		// Чотирикутник 1.
		glVertex2d(0.1, 0.8);
		glVertex2d(0.5, 0.8);
		glVertex2d(0.5, 0.3);
		glVertex2d(0.1, 0.3);

		// Чотирикутник 2.
		glColor3d(0.6, 0.6, 0.6);
		glVertex2d(0.2, 0.7);
		glVertex2d(0.4, 0.7);
		glVertex2d(0.4, 0.4);
		glVertex2d(0.2, 0.4);

	glEnd();

	glColor3d(1.0, 1.0, 1.0);

	// Багатокутник.
	glBegin(GL_POLYGON);
		glVertex2d(-0.7, 0.3);
		glVertex2d(-0.6, 0.3);
		glVertex2d(-0.5, 0.2);
		glVertex2d(-0.6, -0.1);
		glVertex2d(-0.7, -0.1);
		glVertex2d(-0.8, 0.1);
	glEnd();

	glBegin(GL_LINES);

		// Лінія 1.
		glVertex2d(0, -0.7);
		glVertex2d(0.8, -0.7);

		// Лінія 2.
		glColor3d(0.0, 1.0, 0.0);
		glVertex2d(-0.8, -0.8);
		glVertex2d(0.8, -0.8);

	glEnd();

	glColor3d(1.0, 1.0, 1.0);

	// Замкнута ламана.
	glBegin(GL_LINE_LOOP);
		glVertex2d(-0.5, 0.8);
		glVertex2d(-0.2, 0.7);
		glVertex2d(-0.1, 0.4);
		glVertex2d(-0.1, -0.1);
		glVertex2d(-0.4, 0.1);
	glEnd();

	// Ламана.
	glBegin(GL_LINE_STRIP);
		glVertex2d(-0.4, 0.7);
		glVertex2d(-0.2, 0.6);
		glVertex2d(-0.2, 0.1);
		glVertex2d(-0.3, 0.2);
		glVertex2d(-0.4, 0.4);
	glEnd();

	glBegin(GL_POINTS);
		double x, y;
		for (x = 0; x < 0.8; x += 0.0001) {
			y = sin(x * 20) * 0.2 - 0.05;
			glVertex2d(x, y);
		}
	glEnd();

	glutSwapBuffers();
}

int main(int argc, char** argv) {
	glutInit(&argc, argv);

	glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
	glutInitWindowPosition(80, 10);
	glutInitWindowSize(1200, 700);
	glutCreateWindow("2d primitives");

	// Реєстрація зворотних викликів.
	glutDisplayFunc(renderScene);

	glutMainLoop();
	return 0;
}
