#include <cmath>
#include <GL/glut.h>

float rotationZ = 360.0, position = 0.0, cube1Size = 2.6, cube2Size = 1.5;

void drawCube(float size) {
	float d = size / 2;

	glVertex3f(-d, d, d);
	glVertex3f(d, d, d);

	glVertex3f(d, d, d);
	glVertex3f(d, d, -d);

	glVertex3f(d, d, -d);
	glVertex3f(-d, d, -d);

	glVertex3f(-d, d, -d);
	glVertex3f(-d, d, d);

//----------------------------------------

	glVertex3f(-d, -d, d);
	glVertex3f(d, -d, d);

	glVertex3f(d, -d, d);
	glVertex3f(d, -d, -d);

	glVertex3f(d, -d, -d);
	glVertex3f(-d, -d, -d);

	glVertex3f(-d, -d, -d);
	glVertex3f(-d, -d, d);

//-----------------------------------------

	glVertex3f(-d, d, d);
	glVertex3f(-d, -d, d);

	glVertex3f(d, d, d);
	glVertex3f(d, -d, d);

	glVertex3f(d, d, -d);
	glVertex3f(d, -d, -d);

	glVertex3f(-d, d, -d);
	glVertex3f(-d, -d, -d);
}

void renderScene() {
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	glColor3d(1.0, 1.0, 1.0);
	glLineWidth(3);

	glLoadIdentity();
	glTranslatef(0.0, 0.0, -10);
	glRotatef(20, 1.0, 0.0, 0.0);
	glRotatef(20, 0.0, 1.0, 0.0);
	glRotatef(rotationZ, 0.0, 0.0, 1.0);

	glBegin(GL_LINES);

	drawCube(cube1Size);
	drawCube(cube2Size);

	// Сполучення вершин двох кубів.
	float d1 = cube1Size / 2, d2 = cube2Size / 2;

	glVertex3f(-d1, d1, d1);
	glVertex3f(-d2, d2, d2);

	glVertex3f(d1, d1, d1);
	glVertex3f(d2, d2, d2);

	glVertex3f(d1, d1, -d1);
	glVertex3f(d2, d2, -d2);

	glVertex3f(-d1, d1, -d1);
	glVertex3f(-d2, d2, -d2);

	glVertex3f(-d1, -d1, d1);
	glVertex3f(-d2, -d2, d2);

	glVertex3f(d1, -d1, d1);
	glVertex3f(d2, -d2, d2);

	glVertex3f(d1, -d1, -d1);
	glVertex3f(d2, -d2, -d2);

	glVertex3f(-d1, -d1, -d1);
	glVertex3f(-d2, -d2, -d2);

	glEnd();

	glutSwapBuffers();
}

void windowReshapeFunc(GLint newWidth, GLint newHeight) {
	glViewport(0, 0, newWidth, newHeight);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	GLfloat x = GLfloat(newWidth) / newHeight;
	glFrustum(-x, x, -1.0, 1.0, 4.0, 15.0);
	glMatrixMode(GL_MODELVIEW);
}

void timerFunc(int /* value */ ) { // Спрацювання таймеру.
	rotationZ -= 0.2;
	if (rotationZ <= 0.0) rotationZ = 360.0;

	position += 0.01;
	if (position >= (M_PI * 2)) position = 0.0;
	cube1Size = sin(position) + 1.7;
	cube2Size = sin(position + M_PI) + 1.7;

	glutPostRedisplay(); // Redraw window.
	glutTimerFunc(40, timerFunc, 0); // Setup next timer.
}

int main(int argc, char** argv) {
	glutInit(&argc, argv);

	glutInitDisplayMode(GLUT_DEPTH | GLUT_DOUBLE | GLUT_RGBA);
	glutInitWindowPosition(80, 10);
	glutInitWindowSize(1200, 700);
	glutCreateWindow("Hyper cube");

	// Реєстрація зворотних викликів.
	glutDisplayFunc(renderScene);
	glutReshapeFunc(windowReshapeFunc);
	glutTimerFunc(40, timerFunc, 0); // Set up timer for 40ms.

	glutMainLoop();
	return 0;
}
